/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

#ifndef __FLASH_H__
#define __FLASH_H__

/* BYTE_MODE not yet supported */
#define BYTE_MODE   0
#define WORD_MODE   1

#define S29GL_INFO
#define S29GL_VERBOSE

#include <types.h>

typedef struct s29gl_flash_profile {
    u16 manufacturer_ID;
    u16 device_ID;
    u32 base_address;
    /* u32 nbyte_mode; */   /* byte(0) or word(1) mode */
    u32 device_size;        /* Mbits */
    u32 sector_size;        /* kbytes */
    u32 sector_count;
}s29gl_flash_profile_t;

typedef struct s29gl_flash_cmd {
    volatile u16 *addr0;
    volatile u16 *addr1;
    volatile u16 *cfi_addr;
    volatile u16 *device_ID_x01;
    volatile u16 *device_ID_x0e;
    volatile u16 *device_ID_x0f;   
    volatile u16 *manufacturer_ID;
    volatile u16 *sector_base;
    volatile u16 *word_address;
}s29gl_flash_cmd_t;

/* function prototypes */

int s29gl_init(int);
int s29gl_erase_all(void);
int s29gl_sector_erase(u32);
int s29gl_raw_write(u16*, u32, u32);
bool_t s29gl_is_sector_empty(u32 sector);

#endif /* __FLASH_H__ */

