/*
 * Copyright (c) 2008, Noel Lemouel
 * All rights reserved. See LICENCE file for details.
 */

/* display mode structure definition */

#ifndef __DPY_H__
#define __DPY_H__

typedef struct dpy_mode {
	unsigned long pxl_clk; /* kHz */
	/* horizontal */
	unsigned int hres;  /* active resolution */
	unsigned int hfp;   /* front porch */
	unsigned int hspw;  /* sync pulse width */
	unsigned int hbp;   /* back porch */
	unsigned int hspol; /* sync polarity 0=neg / 1=pos */
	/* vertical */
	unsigned int vres;  /* active resolution */
	unsigned int vfp;   /* front porch */
	unsigned int vspw;  /* sync pulse width */
	unsigned int vbp;   /* back porch */
	unsigned int vspol; /* sync polarity 0=neg / 1=pos */
} dpy_mode_t;

#endif /* __DPY_H__ */
